@use 'sass:list';
@use 'sass:map';
@use 'sass:meta';
@use './tokens';
@use './utils';

$-colors: map.get(tokens.$tokens, 'color');
$-brand-colors: map.get($-colors, 'brand');
$-base-colors: map.get($-colors, 'base');
$-font-colors: map.get($-colors, 'font');
$-data-colors: map.get($-colors, 'dataVisualization');
$-sentiment-colors: map.get($-data-colors, 'sentiments');

/// Lookup a color in a map
/// @param {map} $color-map Map to use for lookup
/// @param {String} $name The color name
/// @return {Color} The color value
@function -get-color($color-map, $name) {
  $fetched-color: map.get($color-map, $name);

  @if meta.type-of($fetched-color) == color {
    @return $fetched-color;
  } @else {
    @error utils.value-not-found("Color `#{$name}`", $color-map);
  }
}

/// Returns a data color
///
/// @param {String} $hue - The data color hue
/// @return {Color} - The data color value
@function sentiment-color($hue) {
  @return -get-color($-sentiment-colors, $hue);
}

/// Returns a brand color
///
/// @param {String} $hue - The brand color hue
/// @return {Color} - The brand color value
@function brand-color($hue) {
  @return -get-color($-brand-colors, $hue);
}

/// Returns a base color
///
/// @param {String} $hue - The base color hue
/// @param {String} $shade - The darkness/lightness of the color. Defaults to 500
/// @return {Color} - The color value
@function base-color($hue, $shade: '500') {
  // White and black have no shades
  $is-white: $hue == 'white';
  $is-black: $hue == 'black';

  @if $is-white or $is-black {
    @return map.get($-base-colors, $hue);
  }

  // Get map of shades
  $fetched-shades: map.get($-base-colors, $hue);

  @if meta.type-of($fetched-shades) != map {
    @error utils.value-not-found("Hue `#{$hue}`", $-base-colors);
  }

  @return -get-color($fetched-shades, $shade);
}

/// Returns a font color
///
/// @param {String} $role - What the font will be placed on
/// @param {String} $tone - The base font color. Light or dark.
/// @param {String} $emphasis - The emphasis level
/// @return {Color} - The font color value
@function font-color($role, $tone: 'dark', $emphasis: 'highEmphasis') {
  // Initial color role lookup
  $fetched-role: map.get($-font-colors, $role);

  @if meta.type-of($fetched-role) != map {
    @error utils.value-not-found("Role `#{$role}`", $-font-colors);
  }

  // Get the map for light or dark. Certain color roles only have one valid tone.
  $safe-tone: $tone;

  @if list.length($fetched-role) == 1 {
    $sole-tone: list.nth(map.keys($fetched-role), 1);

    @if $tone != $sole-tone {
      @warn "Role `#{$role}` does not contain `#{$tone}`. The only valid option is `#{$sole-tone}`.";
    }

    $safe-tone: $sole-tone;
  }

  $fetched-tone: map.get($fetched-role, $safe-tone);

  @if meta.type-of($fetched-tone) != map {
    @error utils.value-not-found("Tone `#{$role}`", $fetched-role);
  }

  // Get the actual color value
  @return -get-color($fetched-tone, $emphasis);
}
